"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.SingleCheckbox = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Checkbox = _interopRequireDefault(require("@material-ui/core/Checkbox"));

var _FormControl = _interopRequireDefault(require("@material-ui/core/FormControl"));

var _FormControlLabel = _interopRequireDefault(require("@material-ui/core/FormControlLabel"));

var _FormHelperText = _interopRequireDefault(require("@material-ui/core/FormHelperText"));

var _FormGroup = _interopRequireDefault(require("@material-ui/core/FormGroup"));

var _FormLabel = _interopRequireDefault(require("@material-ui/core/FormLabel"));

var _propTypesTemplates = require("@data-driven-forms/common/prop-types-templates");

var _formFieldGrid = _interopRequireDefault(require("../form-field-grid/form-field-grid"));

var _validationError = require("../validation-error/validation-error");

var _multipleChoiceList = _interopRequireDefault(require("../multiple-chioce-list/multiple-choice-list"));

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var SingleCheckbox = function SingleCheckbox(props) {
  var _useFieldApi = (0, _useFieldApi2["default"])(_objectSpread(_objectSpread({}, props), {}, {
    type: 'checkbox'
  })),
      input = _useFieldApi.input,
      isReadOnly = _useFieldApi.isReadOnly,
      isDisabled = _useFieldApi.isDisabled,
      isRequired = _useFieldApi.isRequired,
      label = _useFieldApi.label,
      helperText = _useFieldApi.helperText,
      description = _useFieldApi.description,
      validateOnMount = _useFieldApi.validateOnMount,
      meta = _useFieldApi.meta,
      FormFieldGridProps = _useFieldApi.FormFieldGridProps,
      FormControlProps = _useFieldApi.FormControlProps,
      FormGroupProps = _useFieldApi.FormGroupProps,
      FormControlLabelProps = _useFieldApi.FormControlLabelProps,
      CheckboxProps = _useFieldApi.CheckboxProps,
      FormLabelProps = _useFieldApi.FormLabelProps,
      FormHelperTextProps = _useFieldApi.FormHelperTextProps,
      inputProps = _useFieldApi.inputProps,
      rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, ["input", "isReadOnly", "isDisabled", "isRequired", "label", "helperText", "description", "validateOnMount", "meta", "FormFieldGridProps", "FormControlProps", "FormGroupProps", "FormControlLabelProps", "CheckboxProps", "FormLabelProps", "FormHelperTextProps", "inputProps"]);

  var invalid = (0, _validationError.validationError)(meta, validateOnMount);
  var text = invalid || (meta.touched || validateOnMount) && meta.warning || helperText || description;
  return /*#__PURE__*/_react["default"].createElement(_formFieldGrid["default"], FormFieldGridProps, /*#__PURE__*/_react["default"].createElement(_FormControl["default"], (0, _extends2["default"])({
    required: isRequired,
    error: !!invalid,
    component: "fieldset"
  }, FormControlProps), /*#__PURE__*/_react["default"].createElement(_FormGroup["default"], FormGroupProps, /*#__PURE__*/_react["default"].createElement(_FormControlLabel["default"], (0, _extends2["default"])({}, FormControlLabelProps, {
    control: /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], (0, _extends2["default"])({}, input, CheckboxProps, {
      disabled: isDisabled || isReadOnly,
      value: input.name,
      inputProps: _objectSpread({
        readOnly: isReadOnly
      }, inputProps)
    }, rest)),
    disabled: isDisabled || isReadOnly,
    label: /*#__PURE__*/_react["default"].createElement(_FormLabel["default"], FormLabelProps, label)
  })), text && /*#__PURE__*/_react["default"].createElement(_FormHelperText["default"], FormHelperTextProps, text))));
};

exports.SingleCheckbox = SingleCheckbox;
SingleCheckbox.propTypes = {
  input: _propTypesTemplates.input,
  meta: _propTypesTemplates.meta,
  isReadOnly: _propTypes["default"].bool,
  isDisabled: _propTypes["default"].bool,
  isRequired: _propTypes["default"].bool,
  label: _propTypes["default"].node,
  helperText: _propTypes["default"].node,
  description: _propTypes["default"].node,
  validateOnMount: _propTypes["default"].bool,
  FormFieldGridProps: _propTypes["default"].object,
  FormControlProps: _propTypes["default"].object,
  FormGroupProps: _propTypes["default"].object,
  FormControlLabelProps: _propTypes["default"].object,
  CheckboxProps: _propTypes["default"].object,
  FormLabelProps: _propTypes["default"].object,
  FormHelperTextProps: _propTypes["default"].object
};
SingleCheckbox.defaultProps = {
  FormFieldGridProps: {},
  FormControlProps: {},
  FormGroupProps: {},
  FormControlLabelProps: {},
  CheckboxProps: {},
  FormLabelProps: {},
  FormHelperTextProps: {}
};

var Checkbox = function Checkbox(_ref) {
  var options = _ref.options,
      props = (0, _objectWithoutProperties2["default"])(_ref, ["options"]);
  return options ? /*#__PURE__*/_react["default"].createElement(_multipleChoiceList["default"], (0, _extends2["default"])({
    options: options
  }, props)) : /*#__PURE__*/_react["default"].createElement(SingleCheckbox, props);
};

Checkbox.propTypes = {
  options: _propTypes["default"].array
};
var _default = Checkbox;
exports["default"] = _default;