"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Grid = _interopRequireDefault(require("@material-ui/core/Grid"));

var _Button = _interopRequireDefault(require("@material-ui/core/Button"));

var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));

var _styles = require("@material-ui/core/styles");

var _formTemplate = _interopRequireDefault(require("@data-driven-forms/common/form-template"));

var useStyles = (0, _styles.makeStyles)(function () {
  return {
    buttonGroup: {
      display: 'flex',
      justifyContent: 'flex-end',
      '&>button:not(last-child)': {
        marginLeft: 8
      }
    }
  };
});

var Form = function Form(_ref) {
  var children = _ref.children,
      GridContainerProps = _ref.GridContainerProps,
      GridProps = _ref.GridProps,
      props = (0, _objectWithoutProperties2["default"])(_ref, ["children", "GridContainerProps", "GridProps"]);
  return /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
    item: true,
    xs: 12
  }, GridProps), /*#__PURE__*/_react["default"].createElement("form", (0, _extends2["default"])({
    noValidate: true
  }, props), /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
    container: true,
    item: true,
    spacing: 2,
    xs: 12
  }, GridContainerProps), children)));
};

Form.propTypes = {
  children: _propTypes["default"].node,
  GridProps: _propTypes["default"].object,
  GridContainerProps: _propTypes["default"].object
};

var Description = function Description(_ref2) {
  var children = _ref2.children,
      GridProps = _ref2.GridProps,
      props = (0, _objectWithoutProperties2["default"])(_ref2, ["children", "GridProps"]);
  return /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
    item: true,
    xs: 12
  }, GridProps), /*#__PURE__*/_react["default"].createElement(_Typography["default"], (0, _extends2["default"])({
    variant: "body1",
    gutterBottom: true
  }, props), children));
};

Description.propTypes = {
  children: _propTypes["default"].node,
  GridProps: _propTypes["default"].object
};

var Title = function Title(_ref3) {
  var children = _ref3.children,
      GridProps = _ref3.GridProps,
      props = (0, _objectWithoutProperties2["default"])(_ref3, ["children", "GridProps"]);
  return /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
    item: true,
    xs: 12
  }, GridProps), /*#__PURE__*/_react["default"].createElement(_Typography["default"], (0, _extends2["default"])({
    variant: "h3",
    gutterBottom: true
  }, props), children));
};

Title.propTypes = {
  children: _propTypes["default"].node,
  GridProps: _propTypes["default"].object
};

var ButtonGroup = function ButtonGroup(_ref4) {
  var children = _ref4.children,
      GridProps = _ref4.GridProps,
      props = (0, _objectWithoutProperties2["default"])(_ref4, ["children", "GridProps"]);
  var classes = useStyles();
  return /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
    item: true,
    xs: 12
  }, GridProps), /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
    className: classes.buttonGroup
  }, props), children));
};

ButtonGroup.propTypes = {
  children: _propTypes["default"].node,
  GridProps: _propTypes["default"].object
};

var Button = function Button(_ref5) {
  var label = _ref5.label,
      variant = _ref5.variant,
      children = _ref5.children,
      buttonType = _ref5.buttonType,
      props = (0, _objectWithoutProperties2["default"])(_ref5, ["label", "variant", "children", "buttonType"]);
  return /*#__PURE__*/_react["default"].createElement(_Button["default"], (0, _extends2["default"])({
    color: variant,
    variant: "contained"
  }, props), label || children);
};

Button.propTypes = {
  children: _propTypes["default"].node,
  label: _propTypes["default"].node,
  variant: _propTypes["default"].string,
  buttonType: _propTypes["default"].string
};

var MuiFormTemplate = function MuiFormTemplate(props) {
  return /*#__PURE__*/_react["default"].createElement(_formTemplate["default"], (0, _extends2["default"])({
    FormWrapper: Form,
    Button: Button,
    ButtonGroup: ButtonGroup,
    Title: Title,
    Description: Description
  }, props));
};

var _default = MuiFormTemplate;
exports["default"] = _default;