"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _AppBar = _interopRequireDefault(require("@material-ui/core/AppBar"));

var _Tab = _interopRequireDefault(require("@material-ui/core/Tab"));

var _Tabs = _interopRequireDefault(require("@material-ui/core/Tabs"));

var _useFormApi = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-form-api"));

var TabContent = function TabContent(_ref) {
  var name = _ref.name,
      fields = _ref.fields,
      formOptions = _ref.formOptions;
  return /*#__PURE__*/_react["default"].createElement(_react.Fragment, {
    key: name
  }, formOptions.renderForm(fields, formOptions));
};

TabContent.propTypes = {
  name: _propTypes["default"].string.isRequired,
  fields: _propTypes["default"].array.isRequired,
  formOptions: _propTypes["default"].shape({
    renderForm: _propTypes["default"].func.isRequired
  }).isRequired
};

var FormTabs = function FormTabs(_ref2) {
  var fields = _ref2.fields,
      AppBarProps = _ref2.AppBarProps,
      TabsProps = _ref2.TabsProps,
      TabProps = _ref2.TabProps;
  var formOptions = (0, _useFormApi["default"])();

  var _useState = (0, _react.useState)(0),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      activeTab = _useState2[0],
      setActiveTab = _useState2[1];

  return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_AppBar["default"], (0, _extends2["default"])({
    position: "static"
  }, AppBarProps), /*#__PURE__*/_react["default"].createElement(_Tabs["default"], (0, _extends2["default"])({
    value: activeTab,
    onChange: function onChange(_e, tabIndex) {
      return setActiveTab(tabIndex);
    }
  }, TabsProps), fields.map(function (_ref3) {
    var title = _ref3.title,
        name = _ref3.name;
    return /*#__PURE__*/_react["default"].createElement(_Tab["default"], (0, _extends2["default"])({
      key: name,
      label: title
    }, TabProps));
  }))), fields.map(function (field, index) {
    return /*#__PURE__*/_react["default"].createElement("div", {
      key: field.name,
      hidden: index !== activeTab
    }, /*#__PURE__*/_react["default"].createElement(TabContent, (0, _extends2["default"])({}, field, {
      name: field.name,
      formOptions: formOptions
    })));
  }));
};

FormTabs.propTypes = {
  fields: _propTypes["default"].array.isRequired,
  AppBarProps: _propTypes["default"].object,
  TabsProps: _propTypes["default"].object,
  TabProps: _propTypes["default"].object
};
FormTabs.defaultProps = {
  AppBarProps: {},
  TabsProps: {},
  TabProps: {}
};
var _default = FormTabs;
exports["default"] = _default;