"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _pickers = require("@material-ui/pickers");

var _moment = _interopRequireDefault(require("@date-io/moment"));

var _formFieldGrid = _interopRequireDefault(require("../form-field-grid/form-field-grid"));

var _validationError = require("../validation-error/validation-error");

var _propTypesTemplates = require("@data-driven-forms/common/prop-types-templates");

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var TimePicker = function TimePicker(props) {
  var _useFieldApi = (0, _useFieldApi2["default"])(props),
      input = _useFieldApi.input,
      isReadOnly = _useFieldApi.isReadOnly,
      isDisabled = _useFieldApi.isDisabled,
      placeholder = _useFieldApi.placeholder,
      isRequired = _useFieldApi.isRequired,
      label = _useFieldApi.label,
      helperText = _useFieldApi.helperText,
      description = _useFieldApi.description,
      validateOnMount = _useFieldApi.validateOnMount,
      meta = _useFieldApi.meta,
      _useFieldApi$locale = _useFieldApi.locale,
      locale = _useFieldApi$locale === void 0 ? 'en' : _useFieldApi$locale,
      MuiPickersUtilsProviderProps = _useFieldApi.MuiPickersUtilsProviderProps,
      FormFieldGridProps = _useFieldApi.FormFieldGridProps,
      rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, ["input", "isReadOnly", "isDisabled", "placeholder", "isRequired", "label", "helperText", "description", "validateOnMount", "meta", "locale", "MuiPickersUtilsProviderProps", "FormFieldGridProps"]);

  var invalid = (0, _validationError.validationError)(meta, validateOnMount);
  return /*#__PURE__*/_react["default"].createElement(_formFieldGrid["default"], FormFieldGridProps, /*#__PURE__*/_react["default"].createElement(_pickers.MuiPickersUtilsProvider, (0, _extends2["default"])({
    locale: locale,
    utils: _moment["default"]
  }, MuiPickersUtilsProviderProps), /*#__PURE__*/_react["default"].createElement(_pickers.TimePicker, (0, _extends2["default"])({
    fullWidth: true,
    margin: "normal",
    label: label,
    helperText: invalid || (meta.touched || validateOnMount) && meta.warning || helperText || description,
    disabled: isDisabled || isReadOnly,
    placeholder: placeholder,
    required: isRequired,
    error: !!invalid,
    readOnly: isReadOnly
  }, input, {
    value: input.value || null
  }, rest))));
};

TimePicker.propTypes = {
  input: _propTypesTemplates.input,
  meta: _propTypesTemplates.meta,
  isReadOnly: _propTypes["default"].bool,
  isDisabled: _propTypes["default"].bool,
  placeholder: _propTypes["default"].node,
  isRequired: _propTypes["default"].bool,
  label: _propTypes["default"].node,
  helperText: _propTypes["default"].node,
  validateOnMount: _propTypes["default"].bool,
  locale: _propTypes["default"].string,
  description: _propTypes["default"].node,
  FormFieldGridProps: _propTypes["default"].object,
  MuiPickersUtilsProviderProps: _propTypes["default"].object
};
TimePicker.defaultProps = {
  FormFieldGridProps: {},
  MuiPickersUtilsProviderProps: {}
};
var _default = TimePicker;
exports["default"] = _default;